; THERE IS A TIME (2017) for realtime Csound6 - by Arthur B. Hunkins
;  requires a MIDI device with 8-9 knobs/sliders & optional 8 keys/buttons/pads

<CsoundSynthesizer>
<CsOptions>

; for Windows, Mac
-odac -M0  -m0d --expression-opt -b128 -B2048 -+raw_controller_mode=1
; for Linux
;-odac -+rtaudio=alsa -+rtmidi=alsa -M hw:1,0 -m0d --expression-opt -b128 -B2048 -+raw_controller_mode=1

</CsOptions>
<CsInstruments>

	sr = 44100
	ksmps = 10
	nchnls = 1
	0dbfs  = 1

	massign 0, 0

#define CHAN	#1# ; 0 = CC7, CHAN 1-8(9) order as below 
#define CTRL    #20# ; 1st # of 8 consecutive; valid = 0 - 120
#define PITCH	#440# ; default pitch (Hz); default = 440; valid = 360 - 720)
#define PITCHCTRL #-1# ; # of pitch controller; -1 = inactive; valid = -1 - 127; if active, range = 360 - 720Hz
#define NOTE	#-1# ; 1st of 8 MIDI Note #'s for specific freqs
; -1 = no specific "notes" (buttons inactive); 1st note = return to last combined slider freq; notes 2-7 = specific freqs in ascending order; 8th note = highest possible combined slider freq 

	instr 1

ipitch	= ($PITCH > 720? 720: $PITCH)
ipitch	= ($PITCH < 360? 360: ipitch)
kfreq3	init 0
kfreq	ctrl7 ($CHAN == 0? 5: $CHAN), ($CHAN == 0? 7: $CTRL + 4), .1, 30, 1
kfreq2	ctrl7 ($CHAN == 0? 6: $CHAN), ($CHAN == 0? 7: $CTRL + 5), 0, 67.79
kfreq3	= kfreq + kfreq2
knew	changed kfreq3
	if knew == 1 then
kfreq5	= kfreq3
	kgoto skip
	endif
	if $NOTE = -1 goto skip
kstat,kchan,k1,k2 midiin
	if (kstat > 143) && (kstat < 160) && (k2 > 0) then
	if k1 == $NOTE then
kfreq4	= kfreq3
knote	= 1	
	elseif k1 == $NOTE + 1 then
kfreq4	= 44
knote	= 1	
	elseif k1 == $NOTE + 2 then
kfreq4	= 55
knote	= 1	
	elseif k1 == $NOTE + 3 then
kfreq4	= 62.86
knote	= 1	
	elseif k1 == $NOTE + 4 then
kfreq4	= 73.33
knote	= 1	
	elseif k1 == $NOTE + 5 then
kfreq4	= 80
knote	= 1	
	elseif k1 == $NOTE + 6 then
kfreq4	= 88
knote	= 1	
	elseif k1 == $NOTE + 7 then
kfreq4	= 97.79
knote	= 1	
	endif
	endif

	if knote == 1 then
kfreq5	= kfreq4
knote	= 0
	endif

skip:
kfreq6	port kfreq5, .2

kamp	ctrl7 ($CHAN == 0? 1: $CHAN), ($CHAN == 0? 7: $CTRL), 0, .95	
kamp	port kamp, .05
kamp2	ctrl7 ($CHAN == 0? 3: $CHAN), ($CHAN == 0? 7: $CTRL + 2), 0, .2
kamp2	port kamp2, .05
kwav	ctrl7 ($CHAN == 0? 2: $CHAN), ($CHAN == 0? 7: $CTRL + 1), 0, .18	
kwav	port kwav, .05
kwav2a	ctrl7 ($CHAN == 0? 4: $CHAN), ($CHAN == 0? 7: $CTRL + 3), 0, 1, 4 
kwav2a	port kwav2a, .05
kpol	ctrl7 ($CHAN == 0? 7: $CHAN), ($CHAN == 0? 7: $CTRL + 6), 0, .4

	if $PITCHCTRL == -1 then
kpitch	= ipitch
	else
kpitch  ctrl7 ($CHAN == 0? 9: $CHAN), ($CHAN == 0? 7: $PITCHCTRL), 360, 720, 4
kpitch	port kpitch, .05
	endif
kband	ctrl7 ($CHAN == 0? 8: $CHAN), ($CHAN == 0? 7: $CTRL + 7), kpitch * 3.4, kpitch * 6.8, 4

avco	vco2 kamp, kpitch, 2, .75 + kwav
avco2	butterbp avco, kband, kband * .5

aosc	oscil kwav2a, kpitch, 2
aosc2	oscil 1 - (kwav2a * .65), kpitch, 3
aosc3	= kamp2 * (aosc + aosc2)

kpol	= ((kfreq3 > 30) && (kpol > .3)? .3: kpol)
kpol	port kpol, .1
ax	vco2 1, kfreq6, 4, .5 + kpol  	
kx	= k(ax)	
asig	ntrpol avco2, aosc3, kx, -1, 1

	outs asig, asig

	endin

</CsInstruments>
<CsScore>

f1 0 513 16 0 512 4 1
f2 0 8193 10 .06 .23 .035 .001
f3 0 8193 10 1 .015 .002
f4 0 513 16 0 512 2.5 1

i 1 0 36000

</CsScore>
</CsoundSynthesizer>
