; THERE IS A TIME (2017) for realtime Csound6 - by Arthur B. Hunkins
;  Version for the three alternative Csound*6* Android apps found at:
:   http://arthunkins.com/Android_Csound_Apps.htm
;    (All these include the required 8-9 sliders and optional 8 buttons; no other Csound Android apps do.)

<CsoundSynthesizer>
<CsOptions>

-odac -m0d --expression-opt -b512 -B2048

</CsOptions>
<CsInstruments>

	sr = 44100
	ksmps = 10
	nchnls = 1
	0dbfs  = 1


#define PITCH	#440# ; default pitch (Hz); default = 440; valid = 360 - 720)
#define PITCHCTRL #0# ; 1 = slider9 (pitch) on, 0 = off; if active, range = 360 - 720Hz 
#define NOTESON	#0# ; 1 = button notes on, 0 = off
 
	instr 1

ipitch	= ($PITCH > 720? 720: $PITCH)
ipitch	= ($PITCH < 360? 360: ipitch)
kfreq3	init 0
kfreq	chnget "slider5"
kfreqa	tab kfreq, 1, 1
kfreqa	= .1 + (kfreqa * 29.9)
kfreq2	chnget "slider6"
kfreq2	= kfreq2 * 67.79
kfreq3	= kfreqa + kfreq2
knew	changed kfreq3
	if knew == 1 then
kfreq5	= kfreq3
	kgoto skip
	endif
	if $NOTESON == 0 goto skip
k1	chnget "butt1"
k1a	trigger k1, .5, 0
	if k1a == 1 then
kfreq4	= kfreq3
knote	= 1	
	endif
k2	chnget "butt2"
k2a	trigger k2, .5, 0
	if k2a == 1 then
kfreq4	= 44
knote	= 1	
	endif
k3	chnget "butt3"
k3a	trigger k3, .5, 0
	if k3a == 1 then
kfreq4	= 55
knote	= 1	
	endif
k4	chnget "butt4"
k4a	trigger k4, .5, 0
	if k4a == 1 then
kfreq4	= 62.86
knote	= 1	
	endif
k5	chnget "butt5"
k5a	trigger k5, .5, 0
	if k5a == 1 then
kfreq4	= 73.33
knote	= 1	
	endif
k6	chnget "butt6"
k6a	trigger k6, .5, 0
	if k6a == 1 then
kfreq4	= 80
knote	= 1	
	endif
k7	chnget "butt7"
k7a	trigger k7, .5, 0
	if k7a == 1 then
kfreq4	= 88
knote	= 1	
	endif
k8	chnget "butt8"
k8a	trigger k8, .5, 0
	if k8a == 1 then
kfreq4	= 97.79
knote	= 1	
	endif

	if knote == 1 then
kfreq5	= kfreq4
knote	= 0
	endif

skip:
kfreq6	port kfreq5, .2

kamp	chnget "slider1"	
kamp	port kamp * .95, .05
kamp2	chnget "slider3"
kamp2	port kamp2 * .2, .05
kwav	chnget "slider2"	
kwav	port kwav * .18, .05
kwav2a	chnget "slider4" 
kwav2a	tab kwav2a, 4, 1
kwav2a	port kwav2a, .05
kpol	chnget "slider7"
kpol	= kpol * .4

	if $PITCHCTRL == 0 then
kpitch	= ipitch
	else
kpitch  chnget "slider9"
kpitch	tab kpitch, 4, 1
kpitch	= 360 + (kpitch * 360)
kpitch	port kpitch, .05
	endif

kband	chnget "slider8"
kband	tab kband, 4, 1
kband	= (kpitch * 3.4) + (kband * kpitch * 3.4)  

avco	vco2 kamp, kpitch, 2, .75 + kwav
avco2	butterbp avco, kband, kband * .5

aosc	oscil kwav2a, kpitch, 2
aosc2	oscil 1 - (kwav2a * .65), kpitch, 3
aosc3	= kamp2 * (aosc + aosc2)

kpol	= ((kfreq3 > 30) && (kpol > .3)? .3: kpol)
kpol	port kpol, .1
ax	vco2 1, kfreq6, 4, .5 + kpol  	
kx	= k(ax)	
asig	ntrpol avco2, aosc3, kx, -1, 1

	outs asig, asig

	endin

</CsInstruments>
<CsScore>

f1 0 513 16 0 512 4 1
f2 0 8193 10 .06 .23 .035 .001
f3 0 8193 10 1 .015 .002
f4 0 513 16 0 512 2.5 1

i 1 0 36000

</CsScore>
</CsoundSynthesizer>
